/*
 *  No longer being used
 */
define(
		['config', 'jquery', 'bus', 'chart-app/application', 'grid/products', 'product_browser/packages', 'grid/filters/text', 'grid/filters/facet', '../chart_handler', 'chart-app/router', 'page/query', 'storage', 'element', 'vgrid', 'virtual-dom/h', 'vdom-virtualize', 'render-tree', 'facets', 'vgrid/input_filter', 'jquery-ui/button', 'throttle-debounce', 'messages', 'perfect-scrollbar', './view.css', '../product_browser.css'],
		function(ECMWF, $, Bus, ChartApplication, products, packages, text_filter, facet_filter, CH, page, qs, localStorage, DOM, VGrid, h, virtualise, RenderTree, Facets, InputFilter) {

	var config = {
		show_view_buttons: false
	}

	var chart_handlers = CH;
	var page_handlers = {}; // these handlers manage chart-type differences that are outside the scope of chart widget plugins.

	var App = function(){};
	App.prototype = ChartApplication;

	var n_filter_runs = 0;

	return $.extend(true, new App(), {
		config: {
			use_column_width: true
		},

		col1: function(o) {
			var self = this, w = this.widgets;

			// set this to have the product list sorted (can be used for grouping)
			//products.sort_by = 'title';

			App.prototype.col1.apply(this, arguments);

			/*
			this.have_url.done(function() {
				//path_filter.set([page.params.product_path]);
				self.update_category_links();
			});

			this.config.enable_hierarchy && (
				$.extend(self.widgets, {
					category_h2: o.el.h2('Categories'),
					path_links: o.el.ul('.path-links').text('Path links')
				})

				path_filter.events.bind('changed', function(path){
					console.log('-> path_filter changed', path ? path[0][0] : '');
					page.goto_list_page(path ? path[0][0].join('/') : (self._package || ''));
					self.update_category_links();
					self.scroll_to_col2();
				})
			);
			*/

			self.vdom.l.on.render.subscribe(function(){
			})

			facet_filter.events.bind('changed', function() {
				if(self._package && facet_filter._active){
					localStorage[self._package] = JSON.stringify({facet_selection: $.map(facet_filter._active, function(v, i) {
							return i + ',' + v.join(',');
						}).join(';')
					});
				}
			});
		},

		col2: function(o) {
			var self = this, w = this.widgets;

			App.prototype.col2.apply(this, arguments);

			// main-column-wrapper is a scrollwindow for listing and product columns
			// -it is needed for horizontal control but is a big problem vertically because
			// its height needs to be continually adjusted.
			$('.main-column-wrapper').length || w.col2.add(w.col3).appendTo($(ECMWF.options.dom.content_parent || '#main').div('.main-column-wrapper').insertBefore('.column-1'));

			if(false)
			(this.login_box = o.el.div('.login-message')).messages({messageBus: self.login_box.messageBus(), enable_popup: true, message_class: 'col-2-message'});

			products.selection.always = false;
			products.products().then(function(items){
				products.on_load(items);
			})

			products.add_filters([/*TypeFilter,*/ text_filter, facet_filter])

			self.vdom.l.filters.unshift(new InputFilter({
				on_filter: function(text){
					products.lookup_filter_by_name('text').enable().on_change(null, text);
				}
			}))

			w.grid = $('') // used by do_layout - TODO perhaps do_layout should not run until after the grid is created
			products.have.filtering.then(function() {
				self.vdom.r = new RenderTree({
					root: w.col2.content[0],
					tree: virtualise(w.col2.content[0]),
					main: {
						render: function() {
							return h('.panel-content', [vgrid.render()])
						}
					}
				})

				var vgrid = new VGrid({
					renderer: self.vdom.r,
					view_mode: 'simple',
					products: products,
					on_click: self.bind(self._on_thumbnail_click),
					on_middle_click: function(item) {
						window.open(item.name() + (page._path.q || ''), '_blank');
					/*
					},
					// TODO not-implemented
					on_model_change: function(items){
						w.package_select && products.packages.then(w.package_select.init);
					},
					// TODO not-implemented
					on_view_change: function() {
						self._on_resize();
					*/
					}
				})

				// TODO we want the callback to always run imediately but options.state is not set - can it be set, or should we add an always argument to subscribe() ?
				products.subscribe(self, self.vdom.r.bind(self.vdom.r.render));
				if(products.filtered) self.vdom.r.render_now();

				// TODO panel-content is no longer needed?
				w.grid = o.el.find('.panel-content')
			})

			products.subscribe(function(){
				if(w.facets && products.lookup_filter_by_name('facets')){
					if(!facet_filter.status()) w.facets.clear();
					w.facets.on_filter_change(); // the facets widget doesnt know about the filter list so the change handler is triggered manually
				}

				w.package_select && w.package_select.on_filter_change();

				// filter changes have no impact on history state unless the view is changed from product to listing.
				n_filter_runs && self.col2.css.left && page.add_state();

				self.on_filter_change();

				self._on_resize();

				// TODO layout sometimes happens before grid-items height is being set.
				setTimeout(self.bind(self._on_resize), 1000);

				n_filter_runs++;
			});

			products.on.items.subscribe(function() {
				window.is_node || console.log('%cpackage change:', 'background-color:#ff9', products.query.package);
				packages.get(self._package).then(function(pkg){
					$.each(page_handlers, function(i, v) {
						if(i === 'epsgram'){
							v.remove()
						}
					})

					products.sorted_facets(pkg, ['Product group'], function(fc) {
						self.vdom.l.filters.push(w.facets = new Facets({
							renderer: self.vdom.l,
							products: products,
							facets: fc,
							selection: (function() {
								var r = {};

								var pkg = products.query.package;
								var facet = localStorage[pkg]
									? JSON.parse(localStorage[pkg]).facet_selection
									: null;
								if (page._path.q){
									var args = qs.parse(page._path.q.slice(1));
									if (args.facets){
										facet = args.facets;
									}
								}
								// example url query: ?facets=Product group,Basic EFI;Component,Atmosphere,Geography
								if(facet){
									var facets = facet.split(';');
									$.each(facets, function(i, v) {
										var f = v.split(',');
										if(f.length > 1){
											r[f.shift()] = $.map(f, function(v, i) { return $.trim(v); });
										}
									});
								}
								return r;
							})(),
							on_change: function(a, b, val, user_initiated) {
								facet_filter.set([a, b], val);
								user_initiated && self.col2.css.left && page.goto_list_page();
							}
						}));
					})
				})

				// navigation
				products.packages.then(function(pkgs) {
					var p = $.findWhere(pkgs, {name: products.query.package});
					if(p){ // TODO to be consistent, the section should always be present, but empty if there are no links
						p.links && self.vdom.l.sections.unshift({
							name: 'links',
							render: function() {
								return [h('ul.menu', $.map(p.links, function(v){ return h('li.menu__item.is-leaf.leaf', [h('a', {href: v.url}, v.title)]) }))];
							}
						})
						packages.get(self._package).then(self.vdom.l.bind(self.vdom.l.render))
					}
				});
			});

			CH.product_change.subscribe(function() {
			});

			/*
			products.selection.subscribe(function() {
				// -as much as we would like, this cannot be the main handler because we do not get clicks on an already-selected product.
			});
			*/

			o.el.show();

			this.col2.css = {left: 0, width: 400, height: 400};
			this.col3.css = {};

			delete this.col2.css.height;

			this._package && packages.get(this._package).then(function(pkg){
				setTimeout(function(){
					if(pkg && pkg.additional_links && pkg.additional_links.length){
						var div = w.col2.find('> .additional-links').orelse(function(){
							var div = w.col2.div('.additional-links')
							div.h3('Additional charts');
							div.ul();
							return div;
						});
						var ul = div.find('> ul');
						$.each(pkg.additional_links, function(i, v) {
							var external = v.url.indexOf(page.base_path) !== 0;
							var a = ul.li().a({href: v.url.replace('@BACKEND', '//' + ECMWF.options.backend_host), rel: external ? 'external' : ''});
							a.img({src: v.thumbnail.replace('@BACKEND', '//' + ECMWF.options.backend_host)});
							a.div('.title').text(v.title);
						});
						self._on_resize();
					}
				}, 3000)
			});
		},

		col3: function(o) {
			var self = this;
			var panel = this.col3;
			panel.widgets = {results: {}};

			App.prototype.col3.apply(this, arguments);

			//o.el.show(); - dont show too early

			this.col3.size = {};

			delete this.col3.css.height;

			this.size_override_targets = $('.top-bar #main').orelse(function(){ return $('#centred, #top, #footer > div'); }); // www vs apps

			Bus()
				.listen('chart-added', function() {
					CH.widgets.chart.messageBus().listen('chart-product-availability', function(_, msg) {
						if(msg.valid_time.values.length > 1){
							self._on_resize();
						}
					});
				})
				// TODO there is a better way than forwarding global to local bus?
				.listen('prev-step', function() {
					(CH.current === CH.interactive) && CH.current.bus.send('prev-step');
				})
				.listen('next-step', function() {
					(CH.current === CH.interactive) && CH.current.bus.send('next-step');
				/*
				})
				.listen('tool-animation-toggle', function() {
					(CH.current === CH.interactive) && CH.current.bus.send('tool-animation-toggle');
				*/
				});

			$.extend(this.widgets, {
				chart_container: o.el.find('> .chart-container').orelse(function(){ return o.el.div('.chart-container') }), // with interactive charts, the container is the width of the chart but the column is wide enough to fill all the available space
				legend: o.el.div('#chart-legends').hide(),
				content: o.el.div('.product-text text-content')
			})

			this.have_chart.done(function() {
				var results = panel.widgets.results;

				(results.button = chart_handlers.widgets.controls.rhs
					.div('.results-button keep')
						.button({label: 'Filter results', icons: {secondary: 'ui-icon-triangle-1-s'}}))
						.prependTo(chart_handlers.widgets.controls.rhs)
						.click(function() {
							self.widgets.col3.find('.ui-menu').not(results.menu || null).hide();

							results.menu = results.menu
								? results.menu.toggle()
								: results.button.ul('.results-menu')
									.menu({
										/*
										select: function(event, ui){
											console.log('selection: ', ui.item.text(), ui.item.attr('data-value'));
											o.on_click(event, ui, o.name);
											self.select(ui.item);

											setTimeout(function() {
												var data = ui.item.parent().data('uiMenu');
												data && (data.mouseHandled = false); // jquery ui menu workaround
											}, 5);
										}
										*/
									})
									.each(function() {
										$(this).div().grid({
											products: products,
											view_mode: 'details',
											text_filter_parent: $(),
											size_fits_content: true,
											enable_status: false,
											on_click: self.bind(self._on_thumbnail_click)
										})
										.find('.scrollable').perfectScrollbar({suppressScrollX: true, wheelSpeed: ECMWF.wheelspeed});

										$(this).find('.outer').div('.mask'); // prevents us having to set the detail item width
									});
							return false;
						});

				chart_handlers.widgets.controls.rhs
					.div('.back-button keep')
						.button({label: 'Back to chart listing', icons: {primary: 'ui-icon-arrowthick-1-w'}, text: false})
						.prependTo(chart_handlers.widgets.controls.rhs)
						.click(function() {
							page.add_state().goto_list_page();
						});

				$('body').off('click', close).click(close);

				function close() {
					results.menu && results.menu.hide();
				}
			});

			/*
			chart_handlers.on.size_change = function(size) {
				self.do_layout();
			}
			*/

			/*
			this.widgets.next = o.el.div('.button-next').click(function() {
				self.widgets.grid.grid('next');
			});
			*/
		},

		on_filter_change: function() {
		},

		_on_thumbnail_click: function(item) {
			if((!page._path.page) || item !== CH.state.list_product){
				page.add_state();

				if(item === CH.state.list_product){
					// the selected product is the same as the previous product
					page.set_product(item.name(), item.title_());
				}else{
					// In this case, the page status is updated via the chart_handler.
					// This is wrong but fixing it requires the chart controls to be decoupled from the chart widget.

					var chart;
					if((chart = CH.widgets.chart && CH.widgets.chart.data('ui-basicChart'))){
						chart.grey();
					}
					this.on_product_select(item);
				}
			}
		},

		scroll_to_col2: function() {
			this.col2.css.left = 0;
			this.col3.css.left = this.col2.css.width;

			this.widgets.col2.css(this.col2.css).attr({sizor: 'viewer.scroll-to-col2'});
			this.widgets.col3.css(this.col3.css);
		},

		scroll_to_col3: function() {
			this.col2.css.left = -this.col2.css.width;
			this.col3.css.left = 0;

			this.widgets.col2.css(this.col2.css);
			this.widgets.col3.css(this.col3.css);

			setTimeout(function() {
				if($(document).scrollTop() > 500){
					$(document).scrollTop($('h1').offset().top - 10)
				}
			}, 1000)
		},

		q_size: function() {
			var q_width = ECMWF.chart.q_width || 256
			var width = Math.max(512, Math.min(1536, Math.floor(this.widgets.col3.width() / q_width) * q_width));
			return {
				width: width,
				height: width * 0.667
			}
		},

		on_product_select: function(product, params) {
			var self = this;

			App.prototype.on_product_select.apply(this, arguments);

			this.scroll_to_col3();

			if(CH.state.list_product === product) return;
			CH.set_state({list_product: product});

			var is_interactive = !!~$.inArray('interactive', product.data.widgets);
			var chart_type = is_interactive ? 'interactive' : 'basic';

			var handler = chart_handlers[chart_type];
			handler.host = this;
			if(handler !== chart_handlers.current){
				var size = self.q_size();

				// 'current' is now set earlier to ensure that it is always set before listeners run.
				// (different require implements have varying amounts of asynchronicity)
				var old_handler = chart_handlers.current;
				chart_handlers.current = handler;

				old_handler && old_handler.cleanup();
				handler.build(product, params || (old_handler && old_handler.state), {el: this.widgets.chart_container, size: size}, function() {
					CH.widgets.chart.messageBus()
						.listen('size-changed', function(_, size) {
							self._on_resize(size);
						})
						.listen('chart-content-update', function(_, msg) {
							self._on_resize();
						})
						.listen('chart-legend-loaded', function() {
							self._on_resize();
						});

					$('body').off('layout.viewer').on('layout.viewer', function() {
						if(is_interactive){
							var size = self.q_size();
							if(size.width !== CH.widgets.chart.width()){
								CH.widgets.chart.css(size);
								CH.widgets.chart.resize();
							}
							// update for height. TODO this negates the point of the check above.
							CH.widgets.chart.css(size);
							CH.widgets.chart.resize();
							self._on_resize();
						}
					});

					$.each(['legend', 'content', 'next'], function(i, v) {
						self.widgets[v] && self.widgets[v].appendTo(self.widgets.col3);
					});

					// update page-level handlers for different chart types
					// TODO don't remove unless is no longer relevant
					$.each(page_handlers, function(i, v) {
						v.remove && v.remove()
					});
					page_handlers = {};
					$.each(product.data.widgets, function(i, v) {
						if(!!~$.inArray(v, ['epsgram'])){
							var A = require('../handlers/epsgram')
							var handler = page_handlers[v] = new A(self)
							if(handler.col1){
								$.merge(self.vdom.l.sections, handler.col1())
							}
						}
					})
				});
			}else{
				handler.update(product);
			}
		},

		// do not call directly, call _on_resize
		_do_layout: window.is_node ? $.noop : function() {
			// TODO column_padding
			var self = this, col2 = self.widgets.col2, col3 = self.widgets.col3, column_padding = 50, window_width = $(window).width();

			(this.widgets.time_navigator && this.widgets.time_navigator.length) || (this.widgets.time_navigator = $('#time-navigator, .time-nav'));
			this.widgets.time_navigator.triggerHandler('layout', {width: this.widgets.time_navigator.width()});

			if(true){
				var col1_width = this._col1_width();
				var left_width = col1_width + (col1_width ? column_padding : 0);

				var r_col_normal_width = this.config.use_column_width
					? window_width - col1_width - 2 * self.config.page.borderx - column_padding
					: 0; // ignore the column width, just use the chart width

				var is_interactive = !!~$.inArray('interactive', CH.state.list_product && CH.state.list_product.data.widgets);
				var q_size = is_interactive ? self.q_size() : {};
				self.col3.size.width = q_size.width || Math.max(r_col_normal_width, (CH.widgets.chart && CH.widgets.chart.find('img').width()) || 480);

				self.col2.css.width = window_width - col1_width - 2 * self.config.page.borderx - column_padding;
				//self.col2.css.width = Math.max(self.col2.css.width, self.col3.size.width); // it prevents having to relayout the page if col2 is the same width as col3

				// TODO there is content below at small screen width due to column wrapping (unless is moved to a menu).
				self.col2.css.height = (col2.find('.catalogue-grid').outerHeight(true) || 1024) + col2.find('.additional-links').outerHeight(true) + 120;

				var w = self.col2.css.width;

				self.col3.size.height = (chart_handlers.widgets.chart ? chart_handlers.widgets.chart.height() : 0) + $('#chart-legends').height() + col3.find('> .block').outerHeight(true) + $('.product-text').height() + 300;
				$('.main-column-wrapper').css({
					width: self.is_landing_page ? '' : self.col3.size.width, // if size is not exactly the same as the natural size, it causes nasty judder, so dont set unless neccesary.
					height: Math.max(self.col2.css.height, self.col3.size.height)
				}).attr({sizor: 'viewer.layout'});

				if(this.is_landing_page){
					$('.main-column-wrapper').css({width: ''})
					this.col2.css.width = r_col_normal_width
				}

				if(self.col2.css.left) self.scroll_to_col3(); else self.scroll_to_col2();

				$.each(page_handlers, function(i, v) {
					v.layout && v.layout();
				});
			}
		},

		on_url_change: function(ctx) {
			var self = this;

			App.prototype.on_url_change.apply(this, arguments);

			if(self.is_landing_page){
				products.have.items.then(function(items) {
					self.h1(products.hierarchy.lookup(page._path.dir).title);
				});
				//products.thumbnail_priority = 'high' // blocks text content
			}else{
				self.have_chart.done(function() {
					self.h1(CH.state.list_product.long_title());
				});
				//products.thumbnail_priority = 'low'
			}
		},

		/*
		update_category_links: function() {
			var self = this;

			this.config.enable_hierarchy && products.products().then(function(items) {
				var children = products.hierarchy.children(page.params.product_path);
				self.widgets.path_links.empty();
				for(var c in children){
					var child = children[c];
					self.widgets.path_links.li().a({href: child.name + '/'}).text(child.title).click(function() {
						console.log('category.click: child=', $(this).attr('href'));
						path_filter.set_child($(this).attr('href').replace('/', ''));
						return false;
					});
				}
				self.widgets.category_h2.text(ECMWF.ucfirst(page.params.product_path[page.params.product_path.length - 1].replace(/-/g, ' ')));

				self.widgets.path_links.add(self.widgets.category_h2)[(!children) || $.isEmptyObject(children) ? 'hide' : 'show']();
			});
		}
		*/
	});
});
