define(['../filter'], function(Filter){

	return new Filter({
		name: 'package',

		fn: function(item){
			if(!this._selected) return true;
			if(item.data.package !== this._selected) return false;
			return true;
		},

		set: function(prop){
			var pkg = prop[0];
			this._selected = pkg;
			this.events.send('changed', [prop, true]);
		},

		deactivate: function() {
			this._selected = null;
			this.events.send('changed');
		},

		status: function() {
			return this._selected;
		},

		_selected: null
	});
});
